from django.shortcuts import render
import os.path
from users.models import Balance
from django.conf import settings
from users.models import User
import operator

def homePage(request):
    iter_var = 0
    all_balance = []
    Cashier = False
    Processor = False

    
    balObject = Balance.objects.filter(user=request.user.id)
    userBalance = balObject.values("balanceValue")
    try:
        userBalance = userBalance[0]['balanceValue'] 
    except IndexError:
        userBalance = None
    if request.user.groups.filter(name='Cashier').exists():
        Cashier = True
    elif request.user.groups.filter(name='Processor').exists():
        Processor = True
    else:
        pass
    if request.user.is_authenticated:
        userQR = f"Name = {request.user.username}, Date Joined = {request.user.date_joined.date()}, ID = {request.user.id}, isCashier={Cashier}, isProcessor={Processor}, Balance = {userBalance}"
    else:
        userQR=None
    a = Balance.objects.all()

    for user in a:
        all_balance.append(user.balanceValue)
    print(f"{all_balance}")
    limited_coins = settings.ALL_COINS - sum(all_balance)
    context = {
        "isCashier": Cashier,
        "isProcessor": Processor,
        "userQR":userQR,
        "fullbalance": limited_coins,
        "currencyTotal": sum(all_balance),
        "userBalance": userBalance
    }

            
    return render(request, "home.html", context)
    

def leaderboard(request):
    users = User.objects.all()
    leaderboard = {}
    for i in users:
        username = i.username
        balance = i.balance.balanceValue
        # add media counter and other stuff 
        if f"{username}" in leaderboard.values():
            leaderboard[username] = balance + leaderboard[username].value
        else:
            leaderboard[username] = balance    
    
    print()
    
    context = {
        "leaderboard":dict(sorted(leaderboard.items(), key=operator.itemgetter(0))),
    }
    return render(request, 'leaderboard.html', context)
 
